"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = action;

var _isobject = _interopRequireDefault(require("isobject"));

var _injection = require("./injection");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; var ownKeys = Object.keys(source); if (typeof Object.getOwnPropertySymbols === 'function') { ownKeys = ownKeys.concat(Object.getOwnPropertySymbols(source).filter(function (sym) { return Object.getOwnPropertyDescriptor(source, sym).enumerable; })); } ownKeys.forEach(function (key) { _defineProperty(target, key, source[key]); }); } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function action(func, inputs, outputs) {
  inputs = (0, _injection.normalizeInputs)('alfaAction', inputs);
  outputs = (0, _injection.normalizeOutputs)('alfaAction', inputs, outputs);

  func.alfaAction = function (store) {
    // const set = store.setWithOutputs(outputs)
    return function (args) {
      var input = store.get(inputs);
      input.set = store.setWithOutputs(outputs);
      var result = func(_objectSpread({}, input, args));

      if ((0, _isobject.default)(result)) {
        input.set(result);
      }
    };
  };

  return func;
}